{const
{
 n=8;
 p : array [1..n,1..n] of byte =
     ((0,0,0,0,0,0,0,0),
      (0,0,0,0,0,0,0,0),
      (0,0,0,0,1,1,1,1),
      (0,0,0,0,1,1,1,1),
      (0,0,0,1,1,1,1,1),
      (0,0,1,1,1,1,1,1),
      (0,0,1,1,1,1,0,0),
      (0,0,1,1,1,0,0,0)
     );
}
{n=4;
 p : array [1..n,1..n] of byte =
     ((1,0,0,1),
      (0,1,1,0),    (*4 6 12 17 21*)
      (0,0,1,1),
      (0,0,1,1)
     );
}
{ n=4;
 p : array [1..n,1..n] of byte =
     ((1,0,0,1),
      (0,1,1,0),    (*6 9 12 14 17 18 19 21*)
      (0,0,1,1),
      (1,0,1,0)
     );
}
{ n=2;
 p : array [1..n,1..n] of byte =
     ((0,0),
      (0,0)    (**)
     );
}
{ n=2;
 p : array [1..n,1..n] of byte =
     ((1,1),
      (1,1)    (* 0 *)
     );
}
type
  marr = array[1..64*64] of longint;
var
 m : marr;
 nn,i,j : word;
 n:integer;
 x,y,k,w2,w : byte;
 p : array [1..64,1..64] of byte;

procedure quicksort(var a: marr; Lo,Hi: integer);

procedure sort(l,r: integer);
var
  i,j,x,y: integer;
begin
  i:=l; j:=r; x:=a[(l+r) DIV 2];
  repeat
    while a[i]<x do i:=i+1;
    while x<a[j] do j:=j-1;
    if i<=j then
    begin
      y:=a[i]; a[i]:=a[j]; a[j]:=y;
      i:=i+1; j:=j-1;
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
end;

begin {quicksort};
  sort(Lo,Hi);
end;

function step(n,s:byte):longint;
var ss:longint; i:byte;
begin
  ss:=1;
  for i:=1 to s do ss:=ss*n;
  step:=ss;
end;

function BW(x,y,w:byte):char;
var
 i,j:byte; sum:integer;
begin
 sum:=0;
 for i:=y to y+w-1 do
  for j:=x to x+w-1 do
   sum:= sum + p[i,j];
 if sum = 0 then BW := 'W'
 else
   if sum = w*w then BW := 'B'
   else BW := 'M';
end;

procedure Tr(x,y,w : byte; num : longint; st : byte);
var
  Pole : char; ts:longint; w2 : byte;
begin
  Pole := BW(x,y,w);
  if Pole='W' then exit;
  if Pole = 'B' then begin
    inc(nn); m[nn]:=num;
  end
  else begin
    ts := step(5,st);
    w2:= w div 2;
    Tr(x,y,w2, 1*ts + num, st+1);
    Tr(x+w2,y,w2, 2*ts + num, st+1);
    Tr(x,y+w2,w2, 3*ts + num, st+1);
    Tr(x+w2,y+w2,w2, 4*ts + num, st+1);
  end;
end;
procedure BWT;
var c:char;
begin
  for i:=1 to n do begin
    for j:=1 to n do begin
      read(c); p[i,j] := ord(c)-48;
    end;
    readln;
  end;
  fillchar(m,SizeOf(m),0);  nn:=0;
  Tr(1,1, n, 0, 0);
  quicksort(m,1,nn);
  writeln('S');
  for i:=1 to nn do
    write(m[i],' ');
  writeln(-1);
end;
procedure UnBWT;
begin
  i:=0; w:=n;
  repeat
    inc(i); read(m[i]);
  until m[i]=-1;
  fillchar(p,SizeOf(p),0);
  nn:=1;
  while m[nn] <> -1 do begin
   i:=m[nn]; w2:=w; x:=1; y:=1; inc(nn);
   repeat
     k:=i mod 5; i:= i div 5;
     w2 := w2 div 2;
    case k of
   0: w2:=w;
   1:;
   2: begin
       x:=x + w2;
      end;
   3: begin
       y:=y+w2;
      end;
   4: begin
       x:=x+w2; y:=y+w2;
      end;
    end;
   until i = 0;

   for i:=y to y+w2-1 do
    for j:=x to x+w2-1 do
     p[i,j] := 1;

  end; {while}
  writeln('I',' ',n);
  for i:=1 to n do  begin
   for j:=1 to n do
    write(p[i,j]);
   writeln;
  end;
end;
begin
  assign(input,'input.txt'); reset(input);
  assign(output,'output.txt'); rewrite(output);
  readln(n);
  if n>0 then BWT
  else begin
   n:=-n; UnBWT;
  end;
  close(input); close(output);
end.